//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link "http://www.metaquotes.net"
//-----------------------------------------------------+
extern bool BuyFlag = true;   
extern bool SellFlag = true;  
extern double TopFilter_Ok;
extern double BotFilter_Ok;
extern double Lots = 0.01;
extern int TakeProfit = 20;
//-----------------------------------------------------+
double ema7,ema14,sma50;						
string sSignal, sCurrentOrderType;							
int iOrders;								
int iDuplicateOrders;	
//-----------------------------------------------------+
int init()
  {
   return(0);
  }
//-----------------------------------------------------+
int deinit()
  {
   return(0);
  }
//-----------------------------------------------------+
int start()
 {
  sSignal = fnGenerateSignal();				
  if (fnShouldWeTrade())
   fnTrade();                                                       
  return(0);
 }
//-----------------------------------------------------+
 string fnGenerateSignal()
 {
  ema7 = iMA(Symbol(),PERIOD_M5,7,0,MODE_EMA,PRICE_CLOSE,0);      	
  ema14 = iMA(Symbol(),PERIOD_M5,14,0,MODE_EMA,PRICE_CLOSE,0);   	
  sma50 = iMA(Symbol(),PERIOD_M5,50,0,MODE_SMA,PRICE_CLOSE,0);    	
  if((ema7>ema14)&&(ema14>sma50)&&(Ask<TopFilter_Ok)) 
   return("BUY");
  if((ema7<ema14)&&(ema14<sma50)&&(Bid>BotFilter_Ok))		
   return("SELL");
  return("PASS");
 }
//-----------------------------------------------------+
bool fnShouldWeTrade()
 {
 if ((sSignal != "BUY") && (sSignal != "SELL"))
  return(false); 
 if (sSignal == "BUY")
  {
   if (!BuyFlag)
    return(false);
  }
 if (sSignal == "SELL")
  {  
   if(!SellFlag)
    return(false);
  }
 if (fnOrderDuplicate())
  return(false);
 return(true);
 }
//-----------------------------------------------------+
bool fnOrderDuplicate()
 {
  iDuplicateOrders = 0;
  iOrders = OrdersTotal()-1;
  for (int i=iOrders; i>=0; i--)
   {
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if ((OrderType() != OP_BUY) && (OrderType() != OP_SELL))
     sCurrentOrderType = "OTHER";
    if (OrderType() == OP_BUY)
     sCurrentOrderType = "BUY"
    if (OrderType() == OP_SELL
     sCurrentOrderType = "SELL";
    if ((OrderSymbol() == Symbol()) && (sCurrentOrderType == sSignal))
        iDuplicateOrders++;
   }
  if (iDuplicateOrders == 0)
   return(false);
  return(true);
 }
//-----------------------------------------------------+
int fnTrade()	
 {
  if (sSignal == "BUY")
   OrderSend(Symbol(),OP_BUY,Lots,Ask,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  else
   OrderSend(Symbol(),OP_SELL,Lots,Bid,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  return(0);
 }
//---- THE END ----